package de.fitconnect.client;

import fitconnect.api.auth.OAuthService;
import fitconnect.api.auth.OAuthToken;
import fitconnect.api.logger.SdkLogger;
import fitconnect.impl.auth.FitCoAuthService;
import fitconnect.impl.SubmissionSender;

import java.net.http.HttpClient;
import java.util.Optional;
import java.util.logging.Level;
import java.util.logging.Logger;

public class ClientBuilder {

    private static final Logger logger = SdkLogger.defaultLogger(ClientBuilder.class);

    private static final String TOKEN_URL = "https://auth-testing.fit-connect.fitko.dev/token";

    private OAuthService authService;
    private SubmissionSender sender;

    private Optional<OAuthToken> token;

    // TODO use DI Container (Guice or Spring)
    public ClientBuilder(){
        this.authService = new FitCoAuthService(HttpClient.newHttpClient(), TOKEN_URL);
        this.sender = new SubmissionSender(authService, null);
    }

    public ClientBuilder authenticate(final String clientId, final String clientSecret){
        this.token = sender.authenticate(clientId, clientSecret, "");
        return this;
    }

    public ClientBuilder printAccessToken(){
        if(token != null){
            logger.log(Level.INFO, token.get().access_token());
        }else{
            logger.log(Level.INFO, "please authenticate first");
        }
        return this;
    }
}
