package de.fitconnect.client;

import fitconnect.api.auth.OAuthService;
import fitconnect.api.crypto.DecryptionService;
import fitconnect.api.crypto.EncryptionService;
import fitconnect.impl.SubmissionSender;
import fitconnect.impl.SubmissionSubscriber;
import fitconnect.impl.auth.FitCoAuthService;
import fitconnect.impl.crypto.JWEDecryptionService;
import fitconnect.impl.crypto.JWEEncryptionService;

import java.net.http.HttpClient;

public class ClientFactory {

    private static final String TOKEN_URL = "https://auth-testing.fit-connect.fitko.dev/token";

    public static SubmissionSender submissionSender(){
        final OAuthService authService = getAuthService();
        final EncryptionService encryptionService = new JWEEncryptionService();
        return new SubmissionSender(authService, encryptionService);
    }

    public static SubmissionSubscriber submissionSubscriber(){
        final OAuthService authService = getAuthService();
        final DecryptionService decryptionService = new JWEDecryptionService();
        return new SubmissionSubscriber(authService, decryptionService);
    }

    private static FitCoAuthService getAuthService() {
        return new FitCoAuthService(HttpClient.newHttpClient(), TOKEN_URL);
    }
}
